# Generated by Django 5.1.2 on 2024-10-25 12:32

import django.db.models.deletion
from django.db import migrations, models

def fill_position(apps, schema_editor):
    OperationLine = apps.get_model('operations', 'OperationLine')
    Position = apps.get_model('seawatch_registration', 'Position')
    position_by_key = {
        position.key: position
        for position in Position.objects.all()
    }
    position_by_key['default'] = None
    for operation_line in OperationLine.objects.all():
        if operation_line.rank not in position_by_key:
            raise ValueError(f"Position with key {operation_line.rank} not found")
        operation_line.position = position_by_key.get(operation_line.rank)

def clear_position(apps, schema_editor):
    OperationLine = apps.get_model('operations', 'OperationLine')
    OperationLine.objects.all().update(position=None)

class Migration(migrations.Migration):

    dependencies = [
        ('operations', '0009_operationline_permanent_crew_and_more'),
        ('seawatch_registration', '0042_split_2nd_3rd_engineer'),
    ]

    operations = [
        migrations.AddField(
            model_name='operationline',
            name='position',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='seawatch_registration.position'),
        ),
        migrations.RunPython(
            fill_position,
            clear_position,
        ),
        migrations.RemoveField(
            model_name='operationline',
            name='rank',
        )
    ]
